package com.upyuns.platform.rs.website.biz;

import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.upyuns.platform.rs.website.entity.TModel;
import com.upyuns.platform.rs.website.entity.TModelType;
import com.upyuns.platform.rs.website.mapper.TModelMapper;
import com.upyuns.platform.rs.website.mapper.TModelTypeMapper;
import com.upyuns.platform.rs.website.vo.TModelTypeVo;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class TModelTypeBiz extends BaseBiz<TModelTypeMapper, TModelType> {


    public ObjectRestResponse getAll() {
        List<TModelTypeVo> vos = new ArrayList<>();
        List<TModelType> tModelTypes = mapper.selectAll();
        for (TModelType tModelType : tModelTypes) {
            TModelTypeVo vo = new TModelTypeVo();
            BeanUtils.copyProperties(tModelType, vo);
            vos.add(vo);
        }
        List<TModelTypeVo> result = new ArrayList<>();
        for (TModelTypeVo vo : vos) {
            if (vo.getPid().equals(0)) {
                result.add(findChildren(vo, vos));
            }
        }

        return ObjectRestResponse.succ(result);
    }


    public TModelTypeVo findChildren(TModelTypeVo vo, List<TModelTypeVo> treeNodes) {
        vo.setChildren(new ArrayList<>());
        for (TModelTypeVo it : treeNodes) {
            if (vo.getId().equals(it.getPid())) {
                vo.getChildren().add(it);
                findChildren(it, treeNodes);
            }
        }
        return vo;
    }

}
